# projet3_temperature
### Membres du groupe :
* THUREL Tim
* ~~ROCHES Thomas~~
* SCHRAMM-HENRY Anatole

Programmes de test et code source de l'application.

Structure du projet :
``` json
/
|_doc
|_lib
|_src
|_test
```
Le dossier **doc** contient toutes la documentation en lien avec le projet  
Le dossier **lib** contient toutes les bibliothèques nécessaires au fonctionnement des périphériques (LTC2497, STS21, LTC2439, etc) ainsi que des objets afin de faciliter rendant testable le developpement.
Le dossier **src** contient le code source de l'application  
Le dossier **test** contient les différents tests effectuées lors des différentes phases (prototypage, écriture de bibliothèques etc)

#### Bibliothèques externes utilisées dans le projet
* [Adafruit_ADS1X15](https://github.com/adafruit/Adafruit_ADS1X15) (Si utilisée avec un ESP8266/32 penser à modifier le délai présent à la ligne 39 : #define ADS1115_CONVERSIONDELAY         (10) afin de ne pas avoir d'erreurs d'acquisition)
* [lmic](https://github.com/matthijskooijman/arduino-lmic) Permet de communiquer avec TTN par l'intermédiaire de la puce SX127X en modulation **LoRa**. Bibliothèque non orientée objet et un peu cru à utiliser...  Wrapper dans notre bibliothèque LoRaRadio qui elle est orientée objet
* [RTCLib](https://github.com/adafruit/RTClib) Permet de dialoguer avec la puce RTC DS3231 pour l'acquisition de l'heure et de la date. La version utilisée est une version modifiée pour un projet personnel.